;
;               Michael Bruno (multiplayer)
;               (mbruno@ieee.org)
;               Ian Graf (port)
;               (ian_graf@geocities.com)
;               Florent Dhordain (original)
;               (flo.dh@usa.net)
;               Ahmed El-Helw (original)
;               (ahmedre@bellsouth.net)
; Version:      1.65
; Platform:     Mirage
; Date:         8/20/2006
;---------------------------------------

;#define CHEAT

#define ballx           saferam1        ; 1 byte  - ball x coord
#define bally           ballx+1         ; 1 byte  - ball y coord
#define score           bally+1         ; 2 bytes - score
#define blockcnt        score+2         ; 1 byte  - num blocks
#define tmpx            blockcnt+1      ; 1 byte  - temp x coord
#define state           tmpx+1          ; 1 byte  - recv or send state
#define oballx          state+1         ; 1 byte  - opponent ball x coord
#define obally          oballx+1        ; 1 byte  - opponent ball y coord
#define oscore          obally+1        ; 2 bytes - opponent's score
#define temp            oscore+2        ; 1 byte  - whatever
#define startsp         temp+1          ; 2 bytes - address of initial sp
#define cballx          startsp+2       ; 1 byte  - temp x coord for coll rout
#define cbally          cballx+1        ; 1 byte  - temp y coord for coll rout
#define cscore          cbally+1        ; 2 bytes - temp score for coll rout
#define cheat1          cscore+2        ; 1 byte  - hmm i donnooo
#define cheat2          cheat1+1        ; 1 byte  - lalala
#define sendrecv        cheat2+1        ; 1 byte  - used in 2 syncing

UP              .equ 1
DOWN            .equ 2
LEFT            .equ 3
RIGHT           .equ 4
NONE            .equ 5
LEAVE           .equ 100

;---------------= header =--------------
#include        "ti83plus.inc"          ;General TI-83 Plus include file
#include        "mirage.inc"            ;MirageOS include file
        .org    $9d93                   ;Origin (set back two)
        .db     $BB,$6D                 ;Compiled AsmPrgm token
        ret                             ;So TIOS wont run the program
        .db     1                       ;Identifier as MirageOS program
        .db     %11111111,%11100111     ;15x15 button
        .db     %00000000,%00000000
        .db     %11110011,%00111111
        .db     %00000000,%00000000
        .db     %10011101,%10111001
        .db     %00000000,%00000000
        .db     %11111001,%10011111
        .db     %00000000,%00000000
        .db     %11110011,%10111011
        .db     %00000000,%00000000
        .db     %11011101,%10110101
        .db     %00000000,%00000000
        .db     %10010011,%11101111
        .db     %00000000,%00000000
        .db     %10111011,%11111001
        .db     "Fall Down",0
                                        ; Program code starts here
        ld      a,%00000100             ;
        out     (0),a                   ; enable link assist on 83+

        ld      (startsp),sp            ;
start:                                  ;
        ld      sp,(startsp)            ; so I can jump to start from anywhere
        bcall(_clrLCDfull)              ;
        ld      de,4*256+0              ;
        ld      (currow),de             ;
        ld      hl,titlestr             ;
        bcall(_puts)                    ;
        ld      bc,0*256+55             ; draw line
        ld      de,94*256+55            ;
        bcall(_darkline)                ;
        ld      de,10*256+1             ; write "By AE, FD, IG, MB"
        ld      (pencol),de             ;
        ld      hl,authorstr            ;
        bcall(_vputs)                   ;
        ld      de,22*256+4             ; write "2nd - Start"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,29*256+4             ; write "Right - Players: "
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,36*256+4             ; write "ALPHA - Speed:"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,43*256+4             ; write "CLEAR - Exit:"
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      de,55*256+1             ; write "High: "
        ld      (pencol),de             ;
        bcall(_vputs)                   ;
        ld      hl,(high)               ;
        bcall(_setxxxxop2)              ; write high score
        bcall(_op2toop1)                ;
        ld      a,5                     ;
        bcall(_dispop1a)                ;
updatm: ld      de,36*256+53            ; write speed
        ld      (pencol),de             ;
        ld      a,(speed)               ;
        bcall(_setxxop1)                ;
        bcall(_dispop1a)                ;
        ld      de,29*256+56            ; write players
        ld      (pencol),de             ;
        ld      a,(players)             ;
        bcall(_setxxop1)                ;
        bcall(_dispop1a)                ;
menul:  bcall(_getcsc)                  ;
        cp      skClear                 ; [CLEAR]
        ret     z                       ; quit
        cp      skMode                  ; [MODE]
        jr      nz,noquit               ; quit
        xor     a                       ;
        out     (0),a                   ; disable link assist on 83+
        ret                             ; before returning
noquit: cp      skAlpha                 ; [ALPHA]
        jr      nz,nschng               ;
        ld      hl,speed                ; change speed
        ld      a,(hl)                  ;
        xor     %00000011               ; toggle between 1 and 2
        ld      (hl),a                  ;
        jr      updatm                  ;
nschng: cp      skRight                 ; [RIGHT]
        jr      nz,npchng               ;
        ld      hl,players              ; change # of players
        ld      a,(hl)                  ;
        xor     %00000011               ; toggle between 1 and 2
        ld      (hl),a                  ;
        jr      updatm                  ;
npchng: cp      sk2nd                   ; [2nd]
        jr      nz,menul                ;
        ld      a,(players)             ;
        dec     a                       ;
        jr      z,begin                 ; skip wait if single player
        bcall(_grbufclr)                ;
        call    ifastcopy               ;
        ld      hl,0                    ;
        ld      (currow),hl             ;
        ld      hl,waitstr              ;
        bcall(_PutS)                    ; Print "Waiting..."
        call    getbyte                 ; clear buffer
        ld      a,1                     ; Send the 2nd player signal in case
        call    sendbyte                ; the other player is already waiting
wait:   call    linkwait                ; Now wait for the other player
        jp      z,start                 ; cancel wait
        call    getbyte                 ;
        or      a                       ;
        jr      z,p2                    ; recieved a zero, must be player 2
        dec     a                       ;
        jp      z,p1                    ; recieved a one, must be player 1
        jr      wait                    ;
p1:     xor     a                       ;
        call    sendbyte                ; player 1 saw player 2, send a zero
        ld      a,1                     ; player 1, go into send state
p2:     ld      (state),a               ; player 2, go into recv state
begin:  bcall(_grbufclr)                ;
        ld      a,1                     ;
        ld      (sendrecv),a            ;
        ld      hl,0                    ; reset score
        ld      (score),hl              ;
        ld      (oscore),hl             ;
        ld      hl,44                   ;
        ld      (ballx),hl              ; ballx,y = 44,0
        ld      hl,44                   ;
        ld      (oballx),hl             ; ballx,y = 44,0
init:   call    randomblocks            ;
        ld      a,(temp)                ; is 2 for 1p, 1 for send, 0 for recv
        or      a                       ;
        jr      nz,usescore             ; use score if state=send or 1 player
        ld      hl,(oscore)             ; else use opponent's score
        jr      getbc                   ; it is important to make sure both
usescore:                               ; are using the same score
        ld      hl,(score)              ;
getbc:  add     hl,hl                   ; hl = score*2
        ld      a,24                    ;
        sub     h                       ;
        ld      b,a                     ;
sloop:  ld      (blockcnt),a            ;
        call    scroll                  ;
        ld      hl,ballx                ;
        call    checkcoll               ; check collisions on own ball
        ld      a,(players)             ;
        dec     a                       ;
        jr      z,skip2col              ; skip if single player
        ld      hl,oballx               ;
        call    checkcoll               ; check on opponent's ball
skip2col:
        call    putball                 ; draw ball
        call    iFastCopy               ;
        call    putball                 ; clear ball
        ei                              ;
        ld      a,(speed)               ;
        ld      b,a                     ;
delay:  halt                            ;
        djnz    delay                   ;
move:   ld      a,(players)             ;
        dec     a                       ;
        jr      z,ckkey                 ; just check the keys if 1 player
        ld      a,(state)               ;
        or      a                       ;
        jr      z,getmov                ; if in recv state, get the move
        xor     a                       ; else in send state
        ld      (state),a               ; set state to recv
ckkey:  ld      a,$FF                   ;
        out     (1),a                   ;
        ld      a,$FE                   ;
        out     (1),a                   ;
        in      a,(1)                   ;
#ifdef CHEAT
        bit     3,a                     ; [(up)]
        ld      hl,cheat1               ;
        jr      z,turnchton             ;
        ld      (hl),$00                ;
        jr      ckleft                  ;
turnchton:                              ;
        ld      (hl),$80                ;
#endif
ckleft: bit     1,a                     ; [(left)]
        jr      z,moveleft              ;
        bit     2,a                     ; [(right)]
        jr      z,moveright             ;
donemv: ld      a,(players)             ;
        dec     a                       ;
        jr      nz,endsnd               ; checked by the link routines
        bcall(_getcsc)                  ;
        cp      skClear                 ; [CLEAR]
        jp      z,exit                  ;
        cp      skMode                  ; [MODE]
        jr      nz,endsnd               ;
        ld      a,1                     ; turn off calc
        out     (3),a                   ;
        ei                              ;
        halt                            ;
endsnd: ld      a,(players)             ;
        dec     a                       ;
        jr      z,endturn               ;
        ld      a,(ballx)               ;
#ifdef CHEAT
        ld      hl,cheat1               ;
        or      (hl)                    ; send cheat over in bit 7
#endif
        call    sendbyte                ;
swapturn:
        ld      hl,sendrecv             ;
        ld      a,(hl)                  ;
        xor     %00000011               ; toggle between 1 and 2
        ld      (hl),a                  ;
        rra                             ;
        jr      nc,move                 ; swap turns if sendrecv = 2
endturn:
        ld      a,(blockcnt)            ;
        dec     a                       ;
        jp      nz,sloop                ;
        jp      init                    ;

getmov: ld      a,1                     ;
        ld      (state),a               ; set state to send
        call    getbytesafe             ;
#ifdef CHEAT
        bit     7,a                     ;
        ld      hl,cheat2               ;
        jr      z,nooppcheat            ;
        ld      (hl),$80                ;
        and     $7F                     ;
        jr      setx                    ;
nooppcheat:                             ;
        ld      (hl),$00                ;
#endif
setx:   ld      (oballx),a              ;
        jr      swapturn                ;

moveleft:
        ld      a,(ballx)               ;
        sub     2                       ;
        jr      c,donemv                ; offscreen
        ld      (tmpx),a                ;
        jr      xcheck                  ;
moveright:
        ld      a,(ballx)               ;
        add     a,2                     ;
        cp      96-4                    ;
        jr      nc,donemv               ; offscreen
        ld      (tmpx),a                ;
        add     a,5                     ; check right side
xcheck: ld      hl,bally                ;
        ld      e,(hl)                  ;
        call    iGetPix                 ;
        ld      a,(hl)                  ;
        or      a                       ;
        jp      nz,donemv               ; something in way
        ld      de,5*12                 ;
        add     hl,de                   ; something in way
        ld      a,(hl)                  ;
        or      a                       ;
        jp      nz,donemv               ;
        ld      a,(tmpx)                ;
        ld      (ballx),a               ; move ball
        jp      donemv                  ;

randomblocks:
        ld      b,12                    ; 12 blocks
        ld      hl,gbuf+(60*12)         ;
        ld      a,(players)             ;
        dec     a                       ;
        jr      nz,chkstate             ;
        ld      a,2                     ;
        ld      (temp),a                ; temp = 2 for single player
        jr      rloop1                  ;
chkstate:
        ld      a,(state)               ;
        ld      (temp),a                ; temp = state for 2 player
rloop1: push    bc                      ;
        push    hl                      ;
        ld      a,(temp)                ;
        cp      2                       ;
        jr      z,rndblk                ;
        or      a                       ;
        jr      nz,rndblkm              ; pick the random block on send state
        call    getbytesafe             ; recv the random number
        jr      blkdn                   ;
rndblkm:
        ld      b,4                     ;
        call    iRandom                 ;
        push    af                      ;
        call    sendbyte                ; send the rnd num if in 2 player mode
        pop     af                      ;
        jr      blkdn                   ;
rndblk: ld      b,4                     ;
        call    iRandom                 ; one luck on 5 to have a hole
blkdn:  pop     hl                      ;
        or      a                       ;
        jr      z,rloop3                ; skip space
        ld      ix,block                ;
        ld      de,12                   ;
        ld      b,4                     ; 4 lines
        push    hl                      ;
rloop2: ld      a,(ix+0)                ;
        ld      (hl),a                  ;
        inc     ix                      ;
        add     hl,de                   ;
        djnz    rloop2                  ;
        pop     hl                      ;
rloop3: inc     hl                      ;
        pop     bc                      ;
        djnz    rloop1                  ;

; The following commented out code is from the original source.
; If you look at it however you'll realize it doesn't accomplish
; what it's trying to do. It checks the last brick to see if it's
; there 12 times, rather than check all 12 bricks. Since I don't want
; to change the behavior of anything, and I'm looking to optimize for
; size, instead of adding the code to fix this, I rewrote it below
; to give the same behavior with less code.

;       ld      hl,gbuf+(60*12)         ;
;       ld      b,12                    ;
;       xor     a                       ;
;rloop4:                                ;
;       ld      c,(hl)                  ;
;       rrc     c                       ;
;       adc     a,0                     ;
;       djnz    rloop4                  ;
;       cp      12                      ; less than 12 bricks
;       ret     c                       ;

#ifdef CHEAT
        ld      a,(players)             ;
        dec     a                       ;
        jr      z,skipcheat             ;

        ld      a,(cheat1)              ;
        or      a                       ;
        jr      z,checkcheat2           ;
        ld      a,(ballx)               ;
        srl     a                       ;
        srl     a                       ;
        srl     a                       ; get block num from x coord
        call    blkdn2                  ; put space here, where the ball is

checkcheat2:
        ld      a,(cheat2)              ;
        or      a                       ;
        jr      z,skipcheat             ;
        ld      a,(oballx)              ;
        srl     a                       ;
        srl     a                       ;
        srl     a                       ; get block num from x coord
        call    blkdn2                  ; put space here, where the ball is

skipcheat:
#endif
        ld      a,(gbuf+(60*12))        ;
        or      a                       ;
        ret     z                       ;

        ld      a,(temp)                ;
        cp      2                       ;
        jr      z,rndblk2               ;
        or      a                       ;
        jr      nz,rndblk2m             ; pick the random block on send state
        call    getbytesafe             ; recv the random number
        jr      blkdn2                  ;
rndblk2m:
        ld      b,12                    ;
        call    iRandom                 ;
        push    af                      ;
        call    sendbyte                ; send the rnd num if in 2 player mode
        pop     af                      ;
        jr      blkdn2                  ;
rndblk2:
        ld      b,12                    ;
        call    iRandom                 ; put random space
blkdn2: ld      hl,gbuf+(60*12)         ;
        ld      d,0                     ;
        ld      e,a                     ;
        add     hl,de                   ;
        ld      b,4                     ;
        ld      de,12                   ;
rloop5: ld      (hl),0                  ;
        add     hl,de                   ;
        djnz    rloop5                  ;
        ret                             ;


scroll: ld      hl,gbuf+12              ;
        ld      de,gbuf                 ;
        ld      bc,756                  ;
        ldir                            ;
        ld      h,d                     ;
        ld      l,e                     ;
        inc     e                       ;
        ld      (hl),b                  ;
        ld      c,11                    ;
        ldir                            ;
        ret                             ;

checkcoll:
        ld	de,cballx               ;
        push    hl                      ;
        ld      bc,4                    ;
        ldir                            ;
        call    checkcolla              ;
        pop     de                      ;
cpytmpdat:
        ld      hl,cballx               ;
        ld      bc,4                    ;
        ldir                            ;
        ret                             ;


checkcolla:
        ld      a,(cbally)              ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(cballx)              ;
        call    iGetPix                 ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,ndown                ;
        ld      a,(cbally)              ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(cballx)              ;
        add     a,5                     ;
        call    iGetPix                 ; check right
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,ndown                ;
        ld      hl,(cscore)             ; inc score
        inc     hl                      ;
        ld      (cscore),hl             ;
        ld      hl,cbally               ; move the ball down 
        inc     (hl)                    ;
        ld      a,(hl)                  ;
        cp      60-5                    ;
        ret     c                       ;
        dec     (hl)                    ;
        ret                             ;

ndown:  ld      a,(cbally)              ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(cballx)              ;
        call    iGetPix                 ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,moveup               ; move up
        ld      a,(cbally)              ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(cballx)              ;
        add     a,5                     ;
        call    iGetPix                 ; check right
        ld      a,(hl)                  ;
        or      a                       ;
        ret     z                       ;

moveup: ld      hl,cbally               ;
        dec     (hl)                    ;
        ld      a,(hl)                  ;
        and     %10000000               ; y<0
        ret     z                       ;
        pop     de                      ;
        pop     de                      ;
        call    cpytmpdat               ;
        jr      nolsnd                  ;
exit:   ld      a,(players)             ;
        dec     a                       ;
        jr      z,nolsnd                ;
        ld      a,LEAVE                 ;
        call    sendbyte                ;
nolsnd: bcall(_clrLCDfull)              ;
        bcall(_homeup)                  ;
        ld      hl,scorestr             ;
        bcall(_puts)                    ; write "Your Score:"
        ld      hl,(score)              ;
        bcall(_disphl)                  ;
        ld      a,(players)             ;
        dec     a                       ;
        jr      z,skipoppscore          ;
        bcall(_newline)                 ;
        ld      hl,oscorestr            ;
        bcall(_puts)                    ; write "P2's Score:"
        ld      hl,(oscore)             ;
        bcall(_disphl)                  ;
        ld      hl,(score)              ;
        ld      de,(oscore)             ;
        bcall(_cphlde)                  ;
        jr      c,lose                  ;
        jr      z,tie                   ;
        ld      hl,winstr               ; write "You Win!"
        jr      printwinlose            ;
lose:   ld      hl,losestr              ; write "You Lose!"
        jr      printwinlose            ;
tie:    ld      hl,tiestr               ; write "It's a Tie!"
printwinlose:
        bcall(_newline)                 ;
        bcall(_puts)                    ;
skipoppscore:
        ld      hl,(score)              ;
        ld      de,(high)               ;
        bcall(_cphlde)                  ;
        jr      c,exitl                 ;
        ld      (high),hl               ;
        bcall(_newline)                 ;
        ld      hl,highstr              ;
        bcall(_puts)                    ; write "New High!"
exitl:  bcall(_getcsc)                  ;
        cp      sk2nd                   ;
        jp      z,start                 ;
        cp      skClear                 ;
        jp      z,start                 ;
        cp      skMode                  ;
        jp      z,start                 ;
        jr      exitl                   ;

putball:
        ld      b,6                     ;
        ld      hl,ballx                ;
        ld      a,(hl)                  ;
        inc     hl                      ;
        ld      l,(hl)                  ;
        ld      ix,ball                 ;
        call    iSprite                 ;
        ld      a,(players)             ;
        dec     a                       ;
        ret     z
        ld      b,6                     ;
        ld      hl,oballx               ;
        ld      a,(hl)                  ;
        inc     hl                      ;
        ld      l,(hl)                  ;
        ld      ix,oball                ;
        jp      iSprite                 ;

sendbyte:
        ld      b,a                     ;
        xor     a                       ; must disable link assist on 83+
        out     (0),a                   ; before sending a byte
        ld      a,b                     ;
        call    sendbytetios            ;
        ld      a,%00000100             ; and now we must reenable it
        out     (0),a                   ; :)
        ret                             ;

; using the link assist on the 83+ significantly improves the quality
; of this game. if I just use the built in getbyte routine, the game
; suffers from intermittent pauses. of course the 83+SE,84 calcs don't
; suffer from this naturally, but why call the builtin routine for them
; when I can just read the link assist input buffer port directly?
getbyte:
        in      a,(2)                   ; which calc?
        rla                             ;
        jr      c,check10               ;
        in      a,(5)                   ; check 83+ link assist in buf
        ret                             ;
check10:
        in      a,(10)                  ; check 83+SE,84 link assist in buf
        ret                             ;

; remember exit jumps to start, and start is safe to
; jump to from anywhere as it restores the stack pointer
getbytesafe:
        call    linkwait                ;
        jp      z,exit                  ;
        call    getbyte                 ;
        cp      LEAVE                   ; other guy prolly hit clear
        ret     nz                      ;
        jp      exit                    ;

linkwait:
        bcall(_GetCSC)                  ;
        cp      skClear                 ;
        ret     z                       ; cancel wait
        cp      skMode                  ;
        ret     z                       ; cancel wait
        call    checklink               ;
        ret     nz                      ;
        jr      linkwait                ;

checklink:
        in      a,(2)                   ;
        rla                             ;
        jr      nc,notSE                ; is it a TI83+ or TI83+SE?
SE:
        in      a,(9)                   ; check the 83+SE,84+ link assist
        bit     4,a                     ; entire byte recv'd?
        ret                             ;
notSE:
        in      a,(0)                   ; check the 83+ link assist
        bit     3,a                     ; entire byte recv'd?
        ret                             ;

titlestr:       .db     "Falldown",0
authorstr:      .db     "By AE, FD, IG, MB",0
startstr:       .db     "2nd - Start",0
playerstr:      .db     "Right - Players: ",0
speedstr:       .db     "ALPHA - Speed:",0
exitstr:        .db     "CLEAR - Exit",0
hscorestr:      .db     "High: ",0
oscorestr:      .db     "P2's Score:"
                .db     0
scorestr:       .db     "Your Score:",0
winstr:         .db     "You Win!",0
losestr:        .db     "You Lose!",0
tiestr:         .db     "It's a Tie!"
                .db     0
highstr:        .db     "New High!",0
waitstr:        .db     "Waiting...",0

high:           .dw     0
speed:          .db     2
players:        .db     1

block:  .db     %11111111
        .db     %10000001
        .db     %10111111
        .db     %11111111
ball:   .db     %01111000
        .db     %10110100
        .db     %11001100
        .db     %11001100
        .db     %10110100
        .db     %01111000
oball:  .db     %01111000
        .db     %11001100
        .db     %10110100
        .db     %10110100
        .db     %11001100
        .db     %01111000


        .end

